﻿;-- TIME_STAMP   2020-09-02 14:11:39   v 0.1

#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include 'MouseHover.au3'

Global Const $COLOR_HOOVER = 0xD7EDFF ; helles blau
Global Const $COLOR_NORMAL = 0xE6E6E6 ; helles grau

Global Const $g_iMouseHoverTime = RegRead('HKEY_CURRENT_USER\Control Panel\Mouse', 'MouseHoverTime') ; 400 ms

Global $Form1 = GUICreate("Form1", 514, 330)
GUISetFont(10, 400, 0, 'Arial')

Global $Label1 = GUICtrlCreateLabel("Label1", 96, 88, 92, 33, BitOR($SS_CENTER, $SS_CENTERIMAGE, $WS_BORDER))
GUICtrlSetBkColor(-1, $COLOR_NORMAL)
GUICtrlSetTip(-1, 'Hover-Effekt erst nach 500 ms.')
; Parameter: ControlID/hWnd, HoverFunc, LeaveFunc, HoverTime (ms)
_MouseHover_Register(-1, _HoverFont, _LeaveFont, 500)

Global $Label2 = GUICtrlCreateLabel("Label2", 208, 88, 92, 33, BitOR($SS_CENTER, $SS_CENTERIMAGE, $WS_BORDER))
GUICtrlSetBkColor(-1, 0xFFBBBB)
GUICtrlSetTip(-1, 'Hover-Effekt deaktiviert. Mit Klick auf Label1 aktivieren.')
; Parameter: ControlID/hWnd, HoverFunc, LeaveFunc, HoverTime (ms)
_MouseHover_Register(-1, _HoverBkColor, _LeaveBkColor, 1)

Global $Label3 = GUICtrlCreateLabel("Label3", 320, 88, 92, 33, BitOR($SS_CENTER, $SS_CENTERIMAGE, $WS_BORDER))
GUICtrlSetBkColor(-1, $COLOR_NORMAL)
GUICtrlSetTip(-1, 'Hover-Effekt schon nach 1 ms.')
; Parameter: ControlID/hWnd, HoverFunc, LeaveFunc, HoverTime (ms)
_MouseHover_Register(-1, _HoverBkColor, _LeaveBkColor, 1)

GUISetState(@SW_SHOW)
_MouseHover_UnRegister($Label2) ; mit UnRegister kann man den Hover-Effekt wieder abschalten
While 1
	Local $nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			ExitLoop
		Case $Label1
			GUICtrlSetTip($Label2, 'Hover-Effekt nach ' & $g_iMouseHoverTime & ' ms. Mit Klick auf Label3 deaktivieren.')
			GUICtrlSetBkColor($Label2, $COLOR_NORMAL)
			_MouseHover_Register($Label2, _HoverBkColor, _LeaveBkColor, -1)
		Case $Label2
			If _MouseHover_Update($Label2, _HoverBkColor, _LeaveBkColor, 1) Then GUICtrlSetTip($Label2, 'Hover-Effekt nach 1 ms. Mit Klick auf Label3 deaktivieren.')
		Case $Label3
			GUICtrlSetTip($Label2, 'Hover-Effekt deaktiviert. Mit Klick auf Label1 aktivieren.')
			_MouseHover_UnRegister($Label2)
			GUICtrlSetBkColor($Label2, 0xFFBBBB)
	EndSwitch
WEnd

; Die Funktion, die aufgerufen wird, wenn sich die Maus ueber dem Control-Element befindet
; Als Parameter bekommt man die Control-ID, so kann man die Funktion fuer mehrere Elemente
; verwenden.
Func _HoverFont($idCtrl)
	GUICtrlSetFont($idCtrl, 16, 600, 0, 'Verdana')
EndFunc

; Die Funktion, die aufgerufen wird, wenn die Maus das Control-Element verlaesst
; Als Parameter bekommt man die Control-ID, so kann man die Funktion fuer mehrere Elemente
; verwenden.
Func _LeaveFont($idCtrl)
	GUICtrlSetFont($idCtrl, 10, 400, 0, 'Arial')
EndFunc

; Die Funktion, die aufgerufen wird, wenn sich die Maus ueber dem Control-Element befindet
; Als Parameter bekommt man die Control-ID, so kann man die Funktion fuer mehrere Elemente
; verwenden.
Func _HoverBkColor($idCtrl)
	GUICtrlSetBkColor($idCtrl, $COLOR_HOOVER) ; als Beispiel wird hier die Hintergrundfarbe geaendert
EndFunc

; Die Funktion, die aufgerufen wird, wenn die Maus das Control-Element verlaesst
; Als Parameter bekommt man die Control-ID, so kann man die Funktion fuer mehrere Elemente
; verwenden.
Func _LeaveBkColor($idCtrl)
	GUICtrlSetBkColor($idCtrl, $COLOR_NORMAL) ; als Beispiel wird hier die Hintergrundfarbe geaendert
EndFunc
